(function(){
  var insertPos = null;
  var tabIndex = 0;
  var langResource = {
    'select_for_start'      : 'FOR R[%s]=1 TO %s',
    'select_comment'        : '!Multi_Pass_Weld',
    'select_register_start' : 'R[%s]=R[%s]-1',
    'select_register_end'   : 'R[%s]=R[%s]*2',
    'select_approach'       : 'L P[N] 250mm/sec FINE',
    'select_arc_start'      : 'L P[N] 100mm/sec FINE Weld Start[%s,R[%s]]',
    'select_arc_end'        : 'L P[N] WELD_SPEED FINE Weld End[%s,R[%s]]',
    'select_arc_end_wid'    : 'L P[N] WELD_SPEED FINE Weld End[%s,R[%s],WID:0]',
    'select_escape'         : 'L P[N] 250mm/sec FINE',
    'select_for_end'        : 'ENDFOR',
  };

  function initCallBack(editorArgObj){
    insertPos = editorArgObj.line;

    showPopup();
    return false;
  }

  function showPopup(){
    var pathName = '/frh/inst/arcpack/arcpack_pop.stm';
    tabIndex = window.frameElement.tabIndex;

    top.IHMIComponents.cf.appendFrame(window, pathName, "popup-frame", popupInitialize);
  }

  function popupInitialize(iframe) {
    var frame = iframe.contentWindow;
    var callbackCancel = function(id, operation) {
      top.IHMIComponents.cf.removeFrame(iframe);
    };
    var callbackOk = function(id, operation) {
      packageDeploy(iframe);
      top.IHMIComponents.cf.removeFrame(iframe);
    };

    if (frame.document.getElementById('divTabBegin') !== null) {
      top.IHMIComponents.cf.initTabBeginEnd(frame);
      frame.document.getElementById('divTabBegin').focus();
    }
    top.IHMIComponents.cf.addEventHandler(frame, "load", function() {
      window.frameElement.tabIndex = tabIndex;
    });
    window.frameElement.tabIndex = "-1";

    // refresh
    frame.document.getElementById('inputOkBtn').refresh(null, null, null, null, true, callbackOk);
    frame.document.getElementById('inputCancelBtn').refresh(null, null, null, null, false, callbackCancel);
  }

  function packageDeploy(iframe) {
    var progline = [];
    var frame = iframe.contentWindow;
    var formatter = top.IHMIComponents.cf.format;

    var regNum = frame.dispParam.getRegiNum();
    var selWpNum = frame.dispParam.getSelWpNum();
    var pathObjs = frame.dispParam.getPathObj();
    var selPathData = pathObjs.find(function(value){
      return (value.WP_NUM == selWpNum);
    });

    if(selPathData) {
      var numRegCnt = parseInt(regNum);
      var numRegStrt = numRegCnt + 1;
      var numRegEnd = numRegCnt + 2;

      progline.push(formatter(langResource.select_for_start, String(numRegCnt), selPathData.WP_PATH_NUM));
      progline.push(langResource.select_comment);
      progline.push(formatter(langResource.select_register_end, String(numRegEnd), String(numRegCnt)));
      progline.push(formatter(langResource.select_register_start, String(numRegStrt), String(numRegEnd)));
      progline.push(langResource.select_approach);
      progline.push(formatter(langResource.select_arc_start, selPathData.WP_NUM, String(numRegStrt)));
      if(g_sysval['$AWSCFG.$WELD_ID_ENA'].value){
        progline.push(formatter(langResource.select_arc_end_wid, selPathData.WP_NUM, String(numRegEnd)));
      } else {
        progline.push(formatter(langResource.select_arc_end, selPathData.WP_NUM, String(numRegEnd)));
      }
      progline.push(langResource.select_escape);
      progline.push(langResource.select_for_end);

      top.home.editorAPI.funcs.setTpOrder(insertPos, progline);
    }
  }

  editorAPI.funcs.setDropCallBack('-inst_arcpack', initCallBack);
}());